/*
 * Copyright (c) 1995, the EUROPAGATE consortium (see below).
 *
 * The EUROPAGATE consortium members are:
 *
 *    University College Dublin
 *    Danmarks Teknologiske Videnscenter
 *    An Chomhairle Leabharlanna
 *    Consejo Superior de Investigaciones Cientificas
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation, in whole or in part, for any purpose, is hereby granted,
 * provided that:
 *
 * 1. This copyright and permission notice appear in all copies of the
 * software and its documentation. Notices of copyright or attribution
 * which appear at the beginning of any file must remain unchanged.
 *
 * 2. The names of EUROPAGATE or the project partners may not be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * 3. Users of this software (implementors and gateway operators) agree to
 * inform the EUROPAGATE consortium of their use of the software. This
 * information will be used to evaluate the EUROPAGATE project and the
 * software, and to plan further developments. The consortium may use
 * the information in later publications.
 * 
 * 4. Users of this software agree to make their best efforts, when
 * documenting their use of the software, to acknowledge the EUROPAGATE
 * consortium, and the role played by the software in their work.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED, OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL THE EUROPAGATE CONSORTIUM OR ITS MEMBERS BE LIABLE
 * FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
 * ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND
 * ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

/*
 * Record management - private header file
 *
 * $Log: iso2709p.h,v $
 * Revision 1.9  1995/05/16 09:39:40  adam
 * LICENSE.
 *
 * Revision 1.8  1995/03/30  14:22:11  adam
 * New MARC anchor functions.
 *
 * Revision 1.7  1995/03/29  11:44:25  adam
 * New functions: iso2709_a_.. for record manipulation.
 *
 * Revision 1.6  1995/03/08  12:36:36  adam
 * New function: dbc2709_cvt.
 *
 * Revision 1.5  1995/02/23  08:32:12  adam
 * Changed header.
 *
 * Revision 1.3  1995/02/15  17:43:08  adam
 * Minor changes to the ccl interface. Bug fix in iso2709 module.
 *
 * Revision 1.2  1995/02/10  16:50:26  adam
 * Indicator field moved to 'struct iso2709_dir' from 'struct
 * iso2709_field'.
 * Function iso2709_rm implemented - to delete a MARC record.
 *
 * Revision 1.1.1.1  1995/02/09  17:27:12  adam
 * Initial version of email gateway under CVS control.
 *
 */

#ifndef ISO2709P_H
#define ISO2709P_H

#include <iso2709.h>

struct iso2709_anchor {
    struct iso2709_field **f0;
    struct iso2709_dir   **d0;
    Iso2709Rec           rec;
};

struct iso2709_field {
    char identifier[4];
    char *data;
    struct iso2709_field *next;
};

struct iso2709_dir {
    char tag[4];
    int  length;
    int  offset;
    char *indicator;
    struct iso2709_dir *next;
    struct iso2709_field *fields;
};

struct iso2709_rec {
    int  record_length;
    char record_status[2];
    char implementation_codes[5];
    int  indicator_length;
    int  identifier_length;
    int  base_address;
    char user_systems[4];

    int  length_data_entry;
    int  length_starting;
    int  length_implementation;
    char future_use[2];

    struct iso2709_dir *directory;
};

/* IS3: */
#define ISO2709_RS 035
/* IS2: */
#define ISO2709_FS 036
/* IS1: */
#define ISO2709_IDFS 037


#endif
